kbuild: Parameterize kallsyms generation and correct reporting
[muen/linux.git] / scripts / link-vmlinux.sh
1 #!/bin/sh
2 # SPDX-License-Identifier: GPL-2.0
3 #
4 # link vmlinux
5 #
6 # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7 # $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8 # in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9 # $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10 # (not within --whole-archive), and do not require symbol indexes added.
11 #
12 # vmlinux
13 #   ^
14 #   |
15 #   +--< $(KBUILD_VMLINUX_OBJS)
16 #   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17 #   |
18 #   +--< $(KBUILD_VMLINUX_LIBS)
19 #   |    +--< lib/lib.a + more
20 #   |
21 #   +-< ${kallsymso} (see description in KALLSYMS section)
22 #
23 # vmlinux version (uname -v) cannot be updated during normal
24 # descending-into-subdirs phase since we do not yet know if we need to
25 # update vmlinux.
26 # Therefore this step is delayed until just before final link of vmlinux.
27 #
28 # System.map is generated to document addresses of all kernel symbols
29
30 # Error out on error
31 set -e
32
33 # Nice output in kbuild format
34 # Will be supressed by "make -s"
35 info()
36 {
37         if [ "${quiet}" != "silent_" ]; then
38                 printf "  %-7s %s\n" "${1}" "${2}"
39         fi
40 }
41
42 # Link of vmlinux.o used for section mismatch analysis
43 # ${1} output file
44 modpost_link()
45 {
46         local objects
47
48         objects="--whole-archive                                \
49                 ${KBUILD_VMLINUX_OBJS}                          \
50                 --no-whole-archive                              \
51                 --start-group                                   \
52                 ${KBUILD_VMLINUX_LIBS}                          \
53                 --end-group"
54
55         ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
56 }
57
58 # Link of vmlinux
59 # ${1} - optional extra .o files
60 # ${2} - output file
61 vmlinux_link()
62 {
63         info LD ${2}
64         local lds="${objtree}/${KBUILD_LDS}"
65         local objects
66
67         if [ "${SRCARCH}" != "um" ]; then
68                 objects="--whole-archive                        \
69                         ${KBUILD_VMLINUX_OBJS}                  \
70                         --no-whole-archive                      \
71                         --start-group                           \
72                         ${KBUILD_VMLINUX_LIBS}                  \
73                         --end-group                             \
74                         ${1}"
75
76                 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} -o ${2}      \
77                         -T ${lds} ${objects}
78         else
79                 objects="-Wl,--whole-archive                    \
80                         ${KBUILD_VMLINUX_OBJS}                  \
81                         -Wl,--no-whole-archive                  \
82                         -Wl,--start-group                       \
83                         ${KBUILD_VMLINUX_LIBS}                  \
84                         -Wl,--end-group                         \
85                         ${1}"
86
87                 ${CC} ${CFLAGS_vmlinux} -o ${2}                 \
88                         -Wl,-T,${lds}                           \
89                         ${objects}                              \
90                         -lutil -lrt -lpthread
91                 rm -f linux
92         fi
93 }
94
95 # generate .BTF typeinfo from DWARF debuginfo
96 gen_btf()
97 {
98         local pahole_ver;
99
100         if ! [ -x "$(command -v ${PAHOLE})" ]; then
101                 info "BTF" "${1}: pahole (${PAHOLE}) is not available"
102                 return 0
103         fi
104
105         pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
106         if [ "${pahole_ver}" -lt "113" ]; then
107                 info "BTF" "${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.13"
108                 return 0
109         fi
110
111         info "BTF" ${1}
112         LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
113 }
114
115 # Create ${2} .o file with all symbols from the ${1} object file
116 kallsyms()
117 {
118         info KSYM ${2}
119         local kallsymopt;
120
121         if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
122                 kallsymopt="${kallsymopt} --all-symbols"
123         fi
124
125         if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
126                 kallsymopt="${kallsymopt} --absolute-percpu"
127         fi
128
129         if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
130                 kallsymopt="${kallsymopt} --base-relative"
131         fi
132
133         local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL}               \
134                       ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
135
136         local afile="`basename ${2} .o`.S"
137
138         ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
139         ${CC} ${aflags} -c -o ${2} ${afile}
140 }
141
142 # Perform one step in kallsyms generation, including temporary linking of
143 # vmlinux.
144 kallsyms_step()
145 {
146         kallsymso_prev=${kallsymso}
147         kallsymso=.tmp_kallsyms${1}.o
148         kallsyms_vmlinux=.tmp_vmlinux${1}
149
150         vmlinux_link "${kallsymso_prev}" ${kallsyms_vmlinux}
151         kallsyms ${kallsyms_vmlinux} ${kallsymso}
152 }
153
154 # Create map file with all symbols from ${1}
155 # See mksymap for additional details
156 mksysmap()
157 {
158         ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
159 }
160
161 sortextable()
162 {
163         ${objtree}/scripts/sortextable ${1}
164 }
165
166 # Delete output files in case of error
167 cleanup()
168 {
169         rm -f .tmp_System.map
170         rm -f .tmp_kallsyms*
171         rm -f .tmp_vmlinux*
172         rm -f System.map
173         rm -f vmlinux
174         rm -f vmlinux.o
175 }
176
177 on_exit()
178 {
179         if [ $? -ne 0 ]; then
180                 cleanup
181         fi
182 }
183 trap on_exit EXIT
184
185 on_signals()
186 {
187         exit 1
188 }
189 trap on_signals HUP INT QUIT TERM
190
191 #
192 #
193 # Use "make V=1" to debug this script
194 case "${KBUILD_VERBOSE}" in
195 *1*)
196         set -x
197         ;;
198 esac
199
200 if [ "$1" = "clean" ]; then
201         cleanup
202         exit 0
203 fi
204
205 # We need access to CONFIG_ symbols
206 . include/config/auto.conf
207
208 # Update version
209 info GEN .version
210 if [ -r .version ]; then
211         VERSION=$(expr 0$(cat .version) + 1)
212         echo $VERSION > .version
213 else
214         rm -f .version
215         echo 1 > .version
216 fi;
217
218 # final build of init/
219 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
220
221 #link vmlinux.o
222 info LD vmlinux.o
223 modpost_link vmlinux.o
224
225 # modpost vmlinux.o to check for section mismatches
226 ${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
227
228 info MODINFO modules.builtin.modinfo
229 ${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
230
231 kallsymso=""
232 kallsymso_prev=""
233 kallsyms_vmlinux=""
234 if [ -n "${CONFIG_KALLSYMS}" ]; then
235
236         # kallsyms support
237         # Generate section listing all symbols and add it into vmlinux
238         # It's a three step process:
239         # 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
240         #     but __kallsyms is empty.
241         #     Running kallsyms on that gives us .tmp_kallsyms1.o with
242         #     the right size
243         # 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
244         #     the right size, but due to the added section, some
245         #     addresses have shifted.
246         #     From here, we generate a correct .tmp_kallsyms2.o
247         # 3)  That link may have expanded the kernel image enough that
248         #     more linker branch stubs / trampolines had to be added, which
249         #     introduces new names, which further expands kallsyms. Do another
250         #     pass if that is the case. In theory it's possible this results
251         #     in even more stubs, but unlikely.
252         #     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
253         #     other bugs.
254         # 4)  The correct ${kallsymso} is linked into the final vmlinux.
255         #
256         # a)  Verify that the System.map from vmlinux matches the map from
257         #     ${kallsymso}.
258
259         kallsyms_step 1
260         kallsyms_step 2
261
262         # step 3
263         size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
264         size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
265
266         if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
267                 kallsyms_step 3
268         fi
269 fi
270
271 vmlinux_link "${kallsymso}" vmlinux
272
273 if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
274         gen_btf vmlinux
275 fi
276
277 if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
278         info SORTEX vmlinux
279         sortextable vmlinux
280 fi
281
282 info SYSMAP System.map
283 mksysmap vmlinux System.map
284
285 # step a (see comment above)
286 if [ -n "${CONFIG_KALLSYMS}" ]; then
287         mksysmap ${kallsyms_vmlinux} .tmp_System.map
288
289         if ! cmp -s System.map .tmp_System.map; then
290                 echo >&2 Inconsistent kallsyms data
291                 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
292                 exit 1
293         fi
294 fi